<?php
class ControllerModuleManufactured extends Controller {
	private $error = array();

	public function index() {
    $this->load->type('tipocomum');
    $this->load->helper('ftr_geral');

    $language = $this->language->load('module/manufactured');

    $this->data = array_merge($this->data, $language);

    $this->data['languageForJS'] = array(
      'module/manufactured' => $language
    );

		$this->document->setTitle($this->language->get('heading_title'));

    $this->load->model('setting/setting');
    $this->document->addScript('admin/public/js/module/manufactured.js');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('manufactured', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'));
		}

    $this->data['heading_title'] = $this->language->get('heading_title');

    $this->document->addTypesForJs(array(
      Type_Status::getTypeForJs(),
      Type_ModulePosition::getTypeForJs(),
    ));

    $this->data['ftr_geral'] = new ftr_geral();
    $this->data['Type_Status'] = $this->load->typeForTwig('Type_Status');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_content_top'] = $this->language->get('text_content_top');
		$this->data['text_content_bottom'] = $this->language->get('text_content_bottom');
		$this->data['text_column_left'] = $this->language->get('text_column_left');
		$this->data['text_column_right'] = $this->language->get('text_column_right');
		$this->data['text_title'] = $this->language->get('text_title');

		$this->data['entry_product'] = $this->language->get('entry_product');
		$this->data['entry_limit'] = $this->language->get('entry_limit');
		$this->data['entry_image'] = $this->language->get('entry_image');
		$this->data['entry_layout'] = $this->language->get('entry_layout');
		$this->data['entry_position'] = $this->language->get('entry_position');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['button_add_module'] = $this->language->get('button_add_module');
		$this->data['button_remove'] = $this->language->get('button_remove');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		if (isset($this->error['image'])) {
			$this->data['error_image'] = $this->error['image'];
		} else {
			$this->data['error_image'] = array();
		}

		if (isset($this->error['limit'])) {
			$this->data['error_limit'] = $this->error['limit'];
		} else {
			$this->data['error_limit'] = array();
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'),
      		'separator' => ' :: '
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/manufactured', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL'),
      		'separator' => ' :: '
   		);

		$this->data['action'] = $this->url->link('module/manufactured', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL');

		$this->data['cancel'] = $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL');

		$this->data['token'] = $this->session->data['token'];

		if (isset($this->request->post['manufactured_id'])) {
			$this->data['manufactured_id'] = $this->request->post['manufactured_id'];
		} else {
			$this->data['manufactured_id'] = $this->config->get('manufactured_id');
		}

		if(isset($this->request->post['manufactured_title'])){
				$this->data['manufactured_title'] = $this->request->post['manufactured_title'];
		}else{
				$this->data['manufactured_title'] = $this->config->get('manufactured_title');
		}

		$this->load->model('catalog/manufacturer');

		if (isset($this->request->post['manufactured_id'])) {
			$manufactureds = explode(',', $this->request->post['manufactured_id']);
		} else {
			$manufactureds = explode(',', $this->config->get('manufactured_id'));
		}

		$this->data['manufactureds'] = array();

		foreach ($manufactureds as $manufactured_id) {

			$manufactured_info = $this->model_catalog_manufacturer->getManufacturer($manufactured_id);

			if ($manufactured_info) {
				$this->data['manufactureds'][] = array(
					'manufacturer_id' => $manufactured_info['manufacturer_id'],
					'name'       			=> $manufactured_info['name']
				);
			}
		}

    $this->data['modules'] = array();

		if (isset($this->request->post['manufactured_module'])) {
			$this->data['modules'] = $this->request->post['manufactured_module'];
		} elseif ($this->config->get('manufactured_module')) {
			$this->data['modules'] = $this->config->get('manufactured_module');
    }

		$this->load->dmodel('design/layout');

		$this->data['layouts'] = $this->dmodel_design_layout->getLayouts();

    $this->data['positions'] = Type_ModulePosition::getRemoveArray([Type_ModulePosition::Tp_ColumnRight], true);

		$this->template = 'module/manufactured';
		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->response->setOutput($this->render('module/manufactured'));
  }

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/manufactured')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (isset($this->request->post['manufactured_module'])) {


      $layoutArray = array(
        'layout' => array(),
        'layout_app' => array()
      );
      $layoutArrayApp = array();
			foreach ($this->request->post['manufactured_module'] as $key => $value) {
        if ($value['position'] == Type_ModulePosition::Tp_AppMobile) {
          $layoutArray['layout_app'][$key] = $value['layout_id'];
        } else {
          $layoutArray['layout'][$key] = $value['layout_id'];
        }

				if ($value['limit'] > Type_DefaultValues::Tp_LimitModules99) {
					$this->error['limit'][$key] = $this->language->get('error_limit');
				}
				// if($value['sort_order']==""){
				// 	$this->error['sort_order'][$key]	= $this->language->get('error_sort_order');
				// }

			}



      // $layoutArray = array();
			// foreach ($this->request->post['manufactured_module'] as $key => $value) {
      //     $layoutArray[$key] = $value['layout_id'];
			// 		if (!$value['image_width'] || !$value['image_height']) {
			// 				$this->error['image'][$key] = $this->language->get('error_image');
			// 		}
      //
			// 		if($value['limit']>Type_DefaultValues::Tp_LimitModules){
			// 			$this->error['limit'][$key]	= $this->language->get('error_limit');
			// 		}
      //
			// }
      //
      // $validalayoutArray = array_unique($layoutArray);
      // if(count($validalayoutArray) != count($layoutArray)) {
      // 		$this->error['warning'] = $this->language->get('error_layout');
      // }

		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
